
// The JPEG parser is based on JHEAD, written by Matthias Wandel
// on the web at www.sentex.net/~mwandel/jhead.

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <errno.h>
#include <ctype.h>
#include <limits.h>
#include "../include/tailor.h"
#include "../include/jhead.h"

#define JHEAD_VERSION "1.9"
#define THUMB "_thumb.jpg"


int ShowTags     = FALSE;    // Do not show raw by default.



/////////////////////////
// Thomas Niemann code //
////////////////////////

/*
 * twj replaced with command line versions
int ErrFatal(char *msg) {
    MessageBox(NULL, msg, "Error", MB_OK);
    return 1;
} 

int ErrFatalAll(char *msg) {
    MessageBox(NULL, msg, "Error", MB_OK);
    return 2;
} 
*/
int ErrFatal(char *msg) {
    printf("\t%s\n", msg);
    return 1;
} 

int ErrFatalAll(char *msg) {
    printf("\t%s\n", msg);
    return 2;
}

void ErrNonfatal(char *msg, int a1, int a2) {
    // do nothing
    return;
} 

/*
 * twj-Doesn't appear to be used
int display(const char *fmt, ...) {
	char buf[100];
	va_list ap;

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	MessageBox(NULL, buf, "Info", MB_OK);
	va_end(ap);
	return 1;
}
*/

int getExif(char *fileName, ExifInfo *exif) {
    int rc;

    ResetJpgfile();

    // Start with an empty image information structure.
    memset(&ImageInfo, 0, sizeof(ImageInfo));
    ImageInfo.FlashUsed = -1;
    ImageInfo.MeteringMode = -1;


    if ((rc = ReadJpegFile(fileName, READ_EXIF)))
    	return rc;

    if (FindSection(M_EXIF) == NULL) {
		// no EXIF info
		DiscardData();
		return 1;
    }

    if (ImageInfo.FocalLength == 0) {
        // invalid EXIF info
        DiscardData();
        return 1;
    }
  
    strcpy(exif->make, ImageInfo.CameraMake);
    strcpy(exif->model, ImageInfo.CameraModel);
    strcpy(exif->dateTime, ImageInfo.DateTime);
    exif->width = ImageInfo.Width;
    exif->height = ImageInfo.Height;
    exif->focalLength = ImageInfo.FocalLength;
    exif->speed = ImageInfo.ExposureTime;
    exif->fstop = ImageInfo.ApertureFNumber;
    exif->iso = ImageInfo.ISOequivalent;

    remove(THUMB);
    if (ImageInfo.ThumbnailPointer) {
		FILE *fp;
		if ((fp = fopen(THUMB, "wb"))) {
			fwrite(ImageInfo.ThumbnailPointer, ImageInfo.ThumbnailSize, 1, fp);
			fclose(fp);
		}
		strcpy(exif->thumbPath, THUMB);
    } else {
		strcpy(exif->thumbPath, "");
    }
 
    DiscardData();
    return 0;
}

int copyExif(char *from, char *to) {
    int rc;
 
    ResetJpgfile();
   
    memset(&ImageInfo, 0, sizeof(ImageInfo));
    ImageInfo.FlashUsed = -1;
    ImageInfo.MeteringMode = -1;

    if ((rc = ReadJpegFile(from, READ_EXIF))) return rc;
    DiscardAllButExif();
    if ((rc = ReadJpegFile(to, READ_IMAGE))) return rc;
    unlink(to);
    if ((rc = WriteJpegFile(to))) return rc;

    DiscardData();
    return 0;
}
